/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 21:18:52 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.blogger.model;

/**
 * Model definition for Post.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Blogger API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Post extends com.google.api.client.json.GenericJson {

  /**
   * The author of this Post.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Author author;

  /**
   * Data about the blog containing this Post.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Blog blog;

  /**
   * The content of the Post. May contain HTML markup.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String content;

  /**
   * The JSON meta-data for the Post.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String customMetaData;

  /**
   * The identifier of this Post.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * The kind of this entity. Always blogger#post
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The list of labels this Post was tagged with.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> labels;

  /**
   * The location for geotagged posts.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Location location;

  /**
   * RFC 3339 date-time when this Post was published.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime published;

  /**
   * The container of comments on this Post.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Replies replies;

  /**
   * The API REST URL to fetch this resource from.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String selfLink;

  /**
   * The title of the Post.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * RFC 3339 date-time when this Post was last updated.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime updated;

  /**
   * The URL where this Post is displayed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String url;

  /**
   * The author of this Post.
   * @return value or {@code null} for none
   */
  public Author getAuthor() {
    return author;
  }

  /**
   * The author of this Post.
   * @param author author or {@code null} for none
   */
  public Post setAuthor(Author author) {
    this.author = author;
    return this;
  }

  /**
   * Data about the blog containing this Post.
   * @return value or {@code null} for none
   */
  public Blog getBlog() {
    return blog;
  }

  /**
   * Data about the blog containing this Post.
   * @param blog blog or {@code null} for none
   */
  public Post setBlog(Blog blog) {
    this.blog = blog;
    return this;
  }

  /**
   * The content of the Post. May contain HTML markup.
   * @return value or {@code null} for none
   */
  public java.lang.String getContent() {
    return content;
  }

  /**
   * The content of the Post. May contain HTML markup.
   * @param content content or {@code null} for none
   */
  public Post setContent(java.lang.String content) {
    this.content = content;
    return this;
  }

  /**
   * The JSON meta-data for the Post.
   * @return value or {@code null} for none
   */
  public java.lang.String getCustomMetaData() {
    return customMetaData;
  }

  /**
   * The JSON meta-data for the Post.
   * @param customMetaData customMetaData or {@code null} for none
   */
  public Post setCustomMetaData(java.lang.String customMetaData) {
    this.customMetaData = customMetaData;
    return this;
  }

  /**
   * The identifier of this Post.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The identifier of this Post.
   * @param id id or {@code null} for none
   */
  public Post setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * The kind of this entity. Always blogger#post
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind of this entity. Always blogger#post
   * @param kind kind or {@code null} for none
   */
  public Post setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The list of labels this Post was tagged with.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getLabels() {
    return labels;
  }

  /**
   * The list of labels this Post was tagged with.
   * @param labels labels or {@code null} for none
   */
  public Post setLabels(java.util.List<java.lang.String> labels) {
    this.labels = labels;
    return this;
  }

  /**
   * The location for geotagged posts.
   * @return value or {@code null} for none
   */
  public Location getLocation() {
    return location;
  }

  /**
   * The location for geotagged posts.
   * @param location location or {@code null} for none
   */
  public Post setLocation(Location location) {
    this.location = location;
    return this;
  }

  /**
   * RFC 3339 date-time when this Post was published.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getPublished() {
    return published;
  }

  /**
   * RFC 3339 date-time when this Post was published.
   * @param published published or {@code null} for none
   */
  public Post setPublished(com.google.api.client.util.DateTime published) {
    this.published = published;
    return this;
  }

  /**
   * The container of comments on this Post.
   * @return value or {@code null} for none
   */
  public Replies getReplies() {
    return replies;
  }

  /**
   * The container of comments on this Post.
   * @param replies replies or {@code null} for none
   */
  public Post setReplies(Replies replies) {
    this.replies = replies;
    return this;
  }

  /**
   * The API REST URL to fetch this resource from.
   * @return value or {@code null} for none
   */
  public java.lang.String getSelfLink() {
    return selfLink;
  }

  /**
   * The API REST URL to fetch this resource from.
   * @param selfLink selfLink or {@code null} for none
   */
  public Post setSelfLink(java.lang.String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  /**
   * The title of the Post.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * The title of the Post.
   * @param title title or {@code null} for none
   */
  public Post setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  /**
   * RFC 3339 date-time when this Post was last updated.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getUpdated() {
    return updated;
  }

  /**
   * RFC 3339 date-time when this Post was last updated.
   * @param updated updated or {@code null} for none
   */
  public Post setUpdated(com.google.api.client.util.DateTime updated) {
    this.updated = updated;
    return this;
  }

  /**
   * The URL where this Post is displayed.
   * @return value or {@code null} for none
   */
  public java.lang.String getUrl() {
    return url;
  }

  /**
   * The URL where this Post is displayed.
   * @param url url or {@code null} for none
   */
  public Post setUrl(java.lang.String url) {
    this.url = url;
    return this;
  }

  @Override
  public Post set(String fieldName, Object value) {
    return (Post) super.set(fieldName, value);
  }

  @Override
  public Post clone() {
    return (Post) super.clone();
  }

  /**
   * The author of this Post.
   */
  public static final class Author extends com.google.api.client.json.GenericJson {

    /**
     * The display name.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String displayName;

    /**
     * The identifier of the Post creator.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String id;

    /**
     * The Post author's avatar.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Image image;

    /**
     * The URL of the Post creator's Profile page.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String url;

    /**
     * The display name.
     * @return value or {@code null} for none
     */
    public java.lang.String getDisplayName() {
      return displayName;
    }

    /**
     * The display name.
     * @param displayName displayName or {@code null} for none
     */
    public Author setDisplayName(java.lang.String displayName) {
      this.displayName = displayName;
      return this;
    }

    /**
     * The identifier of the Post creator.
     * @return value or {@code null} for none
     */
    public java.lang.String getId() {
      return id;
    }

    /**
     * The identifier of the Post creator.
     * @param id id or {@code null} for none
     */
    public Author setId(java.lang.String id) {
      this.id = id;
      return this;
    }

    /**
     * The Post author's avatar.
     * @return value or {@code null} for none
     */
    public Image getImage() {
      return image;
    }

    /**
     * The Post author's avatar.
     * @param image image or {@code null} for none
     */
    public Author setImage(Image image) {
      this.image = image;
      return this;
    }

    /**
     * The URL of the Post creator's Profile page.
     * @return value or {@code null} for none
     */
    public java.lang.String getUrl() {
      return url;
    }

    /**
     * The URL of the Post creator's Profile page.
     * @param url url or {@code null} for none
     */
    public Author setUrl(java.lang.String url) {
      this.url = url;
      return this;
    }

    @Override
    public Author set(String fieldName, Object value) {
      return (Author) super.set(fieldName, value);
    }

    @Override
    public Author clone() {
      return (Author) super.clone();
    }

    /**
     * The Post author's avatar.
     */
    public static final class Image extends com.google.api.client.json.GenericJson {

      /**
       * The Post author's avatar URL.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.String url;

      /**
       * The Post author's avatar URL.
       * @return value or {@code null} for none
       */
      public java.lang.String getUrl() {
        return url;
      }

      /**
       * The Post author's avatar URL.
       * @param url url or {@code null} for none
       */
      public Image setUrl(java.lang.String url) {
        this.url = url;
        return this;
      }

      @Override
      public Image set(String fieldName, Object value) {
        return (Image) super.set(fieldName, value);
      }

      @Override
      public Image clone() {
        return (Image) super.clone();
      }

    }
  }

  /**
   * Data about the blog containing this Post.
   */
  public static final class Blog extends com.google.api.client.json.GenericJson {

    /**
     * The identifier of the Blog that contains this Post.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String id;

    /**
     * The identifier of the Blog that contains this Post.
     * @return value or {@code null} for none
     */
    public java.lang.String getId() {
      return id;
    }

    /**
     * The identifier of the Blog that contains this Post.
     * @param id id or {@code null} for none
     */
    public Blog setId(java.lang.String id) {
      this.id = id;
      return this;
    }

    @Override
    public Blog set(String fieldName, Object value) {
      return (Blog) super.set(fieldName, value);
    }

    @Override
    public Blog clone() {
      return (Blog) super.clone();
    }

  }

  /**
   * The location for geotagged posts.
   */
  public static final class Location extends com.google.api.client.json.GenericJson {

    /**
     * Location's latitude.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Double lat;

    /**
     * Location's longitude.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Double lng;

    /**
     * Location name.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * Location's viewport span. Can be used when rendering a map preview.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String span;

    /**
     * Location's latitude.
     * @return value or {@code null} for none
     */
    public java.lang.Double getLat() {
      return lat;
    }

    /**
     * Location's latitude.
     * @param lat lat or {@code null} for none
     */
    public Location setLat(java.lang.Double lat) {
      this.lat = lat;
      return this;
    }

    /**
     * Location's longitude.
     * @return value or {@code null} for none
     */
    public java.lang.Double getLng() {
      return lng;
    }

    /**
     * Location's longitude.
     * @param lng lng or {@code null} for none
     */
    public Location setLng(java.lang.Double lng) {
      this.lng = lng;
      return this;
    }

    /**
     * Location name.
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * Location name.
     * @param name name or {@code null} for none
     */
    public Location setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    /**
     * Location's viewport span. Can be used when rendering a map preview.
     * @return value or {@code null} for none
     */
    public java.lang.String getSpan() {
      return span;
    }

    /**
     * Location's viewport span. Can be used when rendering a map preview.
     * @param span span or {@code null} for none
     */
    public Location setSpan(java.lang.String span) {
      this.span = span;
      return this;
    }

    @Override
    public Location set(String fieldName, Object value) {
      return (Location) super.set(fieldName, value);
    }

    @Override
    public Location clone() {
      return (Location) super.clone();
    }

  }

  /**
   * The container of comments on this Post.
   */
  public static final class Replies extends com.google.api.client.json.GenericJson {

    /**
     * The List of Comments for this Post.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<Comment> items;

    static {
      // hack to force ProGuard to consider Comment used, since otherwise it would be stripped out
      // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
      com.google.api.client.util.Data.nullOf(Comment.class);
    }

    /**
     * The URL of the comments on this post.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String selfLink;

    /**
     * The count of comments on this post.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long totalItems;

    /**
     * The List of Comments for this Post.
     * @return value or {@code null} for none
     */
    public java.util.List<Comment> getItems() {
      return items;
    }

    /**
     * The List of Comments for this Post.
     * @param items items or {@code null} for none
     */
    public Replies setItems(java.util.List<Comment> items) {
      this.items = items;
      return this;
    }

    /**
     * The URL of the comments on this post.
     * @return value or {@code null} for none
     */
    public java.lang.String getSelfLink() {
      return selfLink;
    }

    /**
     * The URL of the comments on this post.
     * @param selfLink selfLink or {@code null} for none
     */
    public Replies setSelfLink(java.lang.String selfLink) {
      this.selfLink = selfLink;
      return this;
    }

    /**
     * The count of comments on this post.
     * @return value or {@code null} for none
     */
    public java.lang.Long getTotalItems() {
      return totalItems;
    }

    /**
     * The count of comments on this post.
     * @param totalItems totalItems or {@code null} for none
     */
    public Replies setTotalItems(java.lang.Long totalItems) {
      this.totalItems = totalItems;
      return this;
    }

    @Override
    public Replies set(String fieldName, Object value) {
      return (Replies) super.set(fieldName, value);
    }

    @Override
    public Replies clone() {
      return (Replies) super.clone();
    }

  }

}
